/*
 * Copyright © 2016 Canonical Ltd.
 *
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License version 3,
 * as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <messaging/group.h>

struct messaging::Group::Private
{
    messaging::Members initial_invitees;
    std::string initial_title;
    std::shared_ptr<messaging::Member> creator;
};

messaging::Group::Group(std::string id, const messaging::Members &initial_invitees, std::string initial_title, const std::shared_ptr<Member> &creator)
        : Recipient{id}, impl{new Private{initial_invitees, initial_title, creator}}
{
}

messaging::RecipientType messaging::Group::type() const
{
    return messaging::RecipientType::group;
}

messaging::Members messaging::Group::initial_invitees() const
{
    return impl->initial_invitees;
}

std::string messaging::Group::initial_title() const
{
    return impl->initial_title;
}

std::shared_ptr<messaging::Member> messaging::Group::creator() const
{
	return impl->creator;
}
